
/*
 * Freedom Desktop
 * Copyright 1994 by Freedom Software
 *
 * Freedom Software retains all rights to Freedom Desktop (hereafter Software)
 * in binary and in source code form.
 *
 * The commercial use of this Software shall be governed by a separate License
 * agreement. Any individual or institution wishing to make commercial use of
 * the Software must sign a license agreement with Freedom Software. In such
 * cases, the Licensee agrees to abide by the terms contained in the License
 * Agreement and not those contained in this document. Examples of commercial
 * use include (without limitation): (i) integration of the Software (source
 * code form), in whole or in part, into a commercial product sold by or on
 * on behalf of the Licensee; (ii) distribution of the Software (binary form or
 * source code form) in combination with a commercial product sold by or on
 * behalf of the Licensee.
 *
 * Freedom Software (Licensor) grants you (Licensee) a license: (i) to use,
 * copy and make changes and improvements to this Software for licensee's
 * internal business purposes; (ii) to use, copy, and distribute this Software
 * or the derivative works provided that the copyright notice and this
 * permission notice appear on all copies and that NO CHARGE is associated
 * with such copies. However, if Licensee distributes any derivative work
 * based on the Software, then Licensee shall (i) notify Licensor in writing
 * (ii) clearly state that such derivative work is a modified and not the
 * original Freedom Desktop distributed by Freedom Software (iii) publish
 * the corresponding machine-readable source code or information as to
 * where it may be obtained. Each time Licensee redistribute the Software
 * or any derivative work, the recipient automatically agrees to abide
 * by the same terms as the Licensee. Licensee may not impose terms
 * more restrictive than the terms granted herein.
 *
 * By using, copying, modifying or distributing this Software (or any
 * derivative work based on this Software) Licensee indicates acceptance
 * of the terms and conditions set forth in this License.
 *
 * Licensor reserves the right to terminate this License immediately on written
 * notice, for material breach by the Licensee.
 *
 * FREEDOM SOFTWARE DISCLAIMS ALL WARRANTIES EXPRESS OR IMPLIED WITH REGARD
 * TO THIS SOFTWARE INCLUDING BUT NOT LIMITED TO ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND  FITNESS,  IN  NO  EVENT  SHALL LICENSOR BE LIABLE
 * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
 * CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE
 */

#include <Xm/Xm.h>
#include <X11/Shell.h>
#include <Xm/PanedW.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/FileSB.h>
#include <Xm/List.h>
#include <Xm/MainW.h>
#include <Xm/MenuShell.h>
#include <Xm/Label.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/ArrowB.h>
#include <Xm/ArrowBG.h>
#include <Xm/CascadeB.h>
#include <Xm/DrawingA.h>
#include <Xm/SelectioB.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include <Xm/ToggleB.h>


#include "Xsh.h"
#include "X.h"

extern void XshFind();
extern void ScrollCreate();
extern void XshChangeTo();
extern void XshDirCreate();
extern void XshOpenTrash();
extern void cancelCopyMoveCB();
extern void createCopyMoveForm();
extern void XshPanedWindowCreate();
extern void XshPrint();
extern void XshCleanupWindow();
extern void createMenuForm();
extern void createPropertiesForm();
extern void XshClose();
extern void XshFileSBoxCreate();
extern void XshKeepSynchronized();
extern void XshCreateActionMenu();
extern void XshProperties();
extern void XshHiddenFiles();
extern void XshHome();
extern void XshCopyTo();
extern void XshEmptyTrash();
extern void XshDirTextCreate();
extern void XshLongListing();
extern void XshMoveTo();
extern void XshNewDirectory();
extern void XshOpen();
extern void XshRemove();
extern void XshSelectAll();
extern void XshSetDirectory();
extern void XshShortListing();
extern void XshSmallIcons();
extern void XshSortByDate();
extern void XshSortByName();
extern void XshSortBySize();
extern void XshSortByType();
extern void XshSynchronize();
extern void XshTerminalMode();
extern void XshUnselectAll();
extern void XshUp();
extern void helpCB();
extern void okCopyMoveCB();
extern void propApplyCB();
extern void propCancelCB();
extern void propNextCB();
extern void propPrevCB();
extern void setXshPixmap();

extern XshCallbackStruct XshCbs;

Widget Create_main_window(parent)
Widget parent;
{
    Arg    	args[36];
    register int argcnt;
    XmString	dummy, dummy1;

    Widget	main_window;
    Widget	menu_bar;
    Widget	menu_shell;
    Widget	separatorD;
    Widget	copy_to_button;
    Widget	move_to_button;
    Widget	pulldown_menu;
    Widget	open_button;
    Widget	separator;
    Widget	new_directory_button;
    Widget	change_to_button;
    Widget	home_button;
    Widget	up_button;
    Widget	properties_button;
    Widget	separatorE;
    Widget	print_button;
    Widget	find_button;
    Widget	remove_button;
    Widget	close_button;
    Widget	file_cascade;
    Widget	menu_shell1;
    Widget	pulldown_menu1;
    Widget	select_all_button;
    Widget	unselect_all_button;
    Widget	edit_cascade;
    Widget	menu_shell2;
    Widget	pulldown_menu2;
    Widget	small_icons_button;
    Widget	icons_button;
    Widget	long_listing_button;
    Widget	separatorG;
    Widget	hidden_toggle;
    Widget	separator1;
    Widget	menu_shell3;
    Widget	sort_pulldown_menu;
    Widget	byname_button;
    Widget	bydate_button;
    Widget	bysize_button;
    Widget	bytype_button;
    Widget	sort_cascade;
    Widget	separatorH;
    Widget	cleanup_button;
    Widget	view_cascade;
    Widget	menu_shell4;
    Widget	pulldown_menu3;
    Widget	onFSButton;
    Widget	menu_shell6;
    Widget	onVersionButton;
    Widget	onFreedomDesktopButton;
    Widget	help_cascade;
    Widget	pulldown_menu5;
    Widget	open_trash_button;
    Widget	empty_trash_button;
    Widget	menu_shell5;
    Widget	pulldown_menu4;
    Widget	actions_cascade;
    Widget	separatorJ;
    Widget	synchronize_button;
    Widget	util_cascade;
    Widget	paned_window1;
    Widget	scrolled_window;
    Widget	directory_label;
    Widget	separatorA;
    Widget	menu_shell7;
    Widget	pulldown_menu6;
    Widget	keep_synchronized_toggle;
    Widget	terminal_mode_toggle;
    Widget	option_cascade;
    Widget	form;
    Widget	paned_window;
    Widget	separatorB;
    Widget	directory_text;
    Widget	label;

    XmRegisterConverters();
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNshowSeparator, True); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 594); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 479); argcnt++;
    main_window = XtCreateWidget("main_window", xmMainWindowWidgetClass,
		parent, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNspacing, 7); argcnt++;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_BAR); argcnt++;
    menu_bar = XtCreateWidget("menu_bar", xmRowColumnWidgetClass, main_window,
	       args, argcnt);

    XtManageChild(menu_bar);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;

    menu_shell = XtCreatePopupShell("menu_shell", xmMenuShellWidgetClass,
		menu_bar, args, argcnt);

    XtManageChild(menu_shell);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    pulldown_menu = XtCreateWidget("pulldown_menu", xmRowColumnWidgetClass,
		menu_shell, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Open", XmSTRING_DEFAULT_CHARSET));argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'O'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>O"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR("Alt+Shift+O", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    open_button = XtCreateWidget("open_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(open_button, XmNactivateCallback, XshOpen, (caddr_t)&XshCbs);
    XtManageChild(open_button);
 
    argcnt = 0;
    separator = XtCreateWidget("separator", xmSeparatorWidgetClass,
		pulldown_menu, args, argcnt);

    XtManageChild(separator);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR("New Directory ..", XmSTRING_DEFAULT_CHARSET)); 	argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'N'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>N"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR("Alt+Shift+N",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    new_directory_button = XtCreateWidget("new_directory_button",
		xmPushButtonWidgetClass, pulldown_menu, args,
		argcnt);
    XmStringFree(dummy);
    XmStringFree(dummy1);

    XtAddCallback(new_directory_button, XmNactivateCallback, XshNewDirectory, 
	(caddr_t) &XshCbs);
    XtManageChild(new_directory_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Change To ..", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'g'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>G"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+Shift+G", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    change_to_button = XtCreateWidget("change_to_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(change_to_button, XmNactivateCallback, XshChangeTo, (caddr_t)&XshCbs);
    XtManageChild(change_to_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Home", XmSTRING_DEFAULT_CHARSET));argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'H'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>H"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
    dummy1=XmStringCreateLtoR( "Alt+Shift+H", XmSTRING_DEFAULT_CHARSET));argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    home_button = XtCreateWidget("home_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(home_button, XmNactivateCallback, XshHome, (caddr_t)&XshCbs);
    XtManageChild(home_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Up", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>U"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+Shift+U", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'U'); argcnt++;
    up_button = XtCreateWidget("up_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(up_button, XmNactivateCallback, XshUp, (caddr_t)&XshCbs);
    XtManageChild(up_button);
 
    argcnt = 0;
    separatorD = XtCreateWidget("separatorD", xmSeparatorWidgetClass,
		pulldown_menu, args, argcnt);

    XtManageChild(separatorD);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Copy To ..", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>C"); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'C'); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+Shift+C",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    copy_to_button = XtCreateWidget("copy_to_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(copy_to_button, XmNactivateCallback, XshCopyTo, 
	(caddr_t)&XshCbs);
    XtManageChild(copy_to_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Move To ..", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'M'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>M"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+Shift+M", XmSTRING_DEFAULT_CHARSET)); 
        argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    move_to_button = XtCreateWidget("move_to_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy);
    XmStringFree( dummy1 );

    XtAddCallback(move_to_button, XmNactivateCallback, XshMoveTo, 
	(caddr_t)&XshCbs);
    XtManageChild(move_to_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Properties ..", XmSTRING_DEFAULT_CHARSET)); 		argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>R"); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'r'); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+Shift+R", XmSTRING_DEFAULT_CHARSET)); 		argcnt++;
    properties_button = XtCreateWidget("properties_button",
		xmPushButtonWidgetClass, pulldown_menu, args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(properties_button, XmNactivateCallback, XshProperties, 
	(caddr_t)&XshCbs);
    XtManageChild(properties_button);
 
    argcnt = 0;
    separatorE = XtCreateWidget("separatorE", xmSeparatorWidgetClass,
		pulldown_menu, args, argcnt);

    XtManageChild(separatorE);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy=XmStringCreateLtoR( "Print ..", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'P'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>P"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+Shift+P", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    print_button = XtCreateWidget("print_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy);
    XmStringFree( dummy1);

    XtAddCallback(print_button, XmNactivateCallback, XshPrint, 
	(caddr_t)&XshCbs);
    XtManageChild(print_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Find ..", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>F"); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'F'); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+Shift+F", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    find_button = XtCreateWidget("find_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy);
    XmStringFree( dummy1);

    XtAddCallback(find_button, XmNactivateCallback, XshFind, (caddr_t)&XshCbs);
    XtManageChild(find_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Move To Trash", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    remove_button = XtCreateWidget("remove_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(remove_button, XmNactivateCallback, XshRemove, 
	(caddr_t)&XshCbs);
    XtManageChild(remove_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (dummy=XmStringCreateLtoR(
		"Close",
		XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt<Key>F4"); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'C'); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+F4", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    close_button = XtCreateWidget("close_button", xmPushButtonWidgetClass,
		pulldown_menu, args, argcnt);
    XmStringFree( dummy  );
    XmStringFree( dummy1 );

    XtAddCallback(close_button, XmNactivateCallback, XshClose, (caddr_t)&XshCbs);
    XtManageChild(close_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "File", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'F'); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldown_menu); argcnt++;
    file_cascade = XtCreateWidget("file_cascade", xmCascadeButtonWidgetClass,
		menu_bar, args, argcnt);
    XmStringFree( dummy);

    XtManageChild(file_cascade);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;

    menu_shell1 = XtCreatePopupShell("menu_shell1", xmMenuShellWidgetClass,
		menu_bar, args, argcnt);

    XtManageChild(menu_shell1);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    pulldown_menu1 = XtCreateWidget("pulldown_menu1", xmRowColumnWidgetClass,
		menu_shell1, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Select All", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'A'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>A"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+Shift+A", XmSTRING_DEFAULT_CHARSET)); 		argcnt++;
    select_all_button = XtCreateWidget("select_all_button", 
		xmPushButtonWidgetClass,
		pulldown_menu1, args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(select_all_button, XmNactivateCallback, XshSelectAll, (caddr_t)&XshCbs);
    XtManageChild(select_all_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (dummy=XmStringCreateLtoR(
		"Unselect All",
		XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'U'); argcnt++;
    unselect_all_button = XtCreateWidget("unselect_all_button",
		xmPushButtonWidgetClass, pulldown_menu1, args, argcnt);
    XmStringFree( dummy);

    XtAddCallback(unselect_all_button, XmNactivateCallback, XshUnselectAll, (caddr_t)&XshCbs);
    XtManageChild(unselect_all_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Edit", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldown_menu1); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'E'); argcnt++;
    edit_cascade = XtCreateWidget("edit_cascade", xmCascadeButtonWidgetClass,
		menu_bar, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(edit_cascade);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;

    menu_shell2 = XtCreatePopupShell("menu_shell2", xmMenuShellWidgetClass,
		menu_bar, args, argcnt);

    XtManageChild(menu_shell2);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNradioBehavior, False); argcnt++;
    XtSetArg(args[argcnt], XmNisHomogeneous, False); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    pulldown_menu2 = XtCreateWidget("pulldown_menu2", xmRowColumnWidgetClass,
		menu_shell2, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Icons", XmSTRING_DEFAULT_CHARSET));argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'I'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>I"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
	dummy1=XmStringCreateLtoR( "Alt+Shift+I", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNindicatorType, XmONE_OF_MANY); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    small_icons_button = XtCreateWidget("small_icons_button",
		xmToggleButtonWidgetClass, pulldown_menu2,
		args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(small_icons_button, XmNvalueChangedCallback, XshSmallIcons, 
	(caddr_t)&XshCbs);
    createMenuForm(small_icons_button, (caddr_t)10, (caddr_t)0);
    XtManageChild(small_icons_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Short Listing", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, ""); argcnt++;
    XtSetArg(args[argcnt], XmNindicatorType, XmONE_OF_MANY); argcnt++;
    XtSetArg(args[argcnt], XmNset, False); argcnt++;
    icons_button = XtCreateWidget("icons_button", xmToggleButtonWidgetClass,
		pulldown_menu2, args, argcnt);
    XmStringFree( dummy);

    XtAddCallback(icons_button, XmNvalueChangedCallback, XshShortListing, 
	(caddr_t)&XshCbs);
    createMenuForm(icons_button, (caddr_t)11, (caddr_t)0);
    XtManageChild(icons_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Long Listing", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'L'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>L"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, (dummy1=XmStringCreateLtoR(
		"Alt+Shift+L",
		XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNindicatorType, XmONE_OF_MANY); argcnt++;
    XtSetArg(args[argcnt], XmNset, False); argcnt++;
    long_listing_button = XtCreateWidget("long_listing_button",
		xmToggleButtonWidgetClass, pulldown_menu2,
		args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(long_listing_button, XmNvalueChangedCallback, 
	XshLongListing, (caddr_t)&XshCbs);
    createMenuForm(long_listing_button, (caddr_t)12, (caddr_t)0);
    XtManageChild(long_listing_button);
 
    argcnt = 0;
    separatorG = XtCreateWidget("separatorG", xmSeparatorWidgetClass,
		pulldown_menu2, args, argcnt);

    XtManageChild(separatorG);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy=XmStringCreateLtoR( "Show Hidden Files", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'H'); argcnt++;
    XtSetArg(args[argcnt], XmNvisibleWhenOff, False); argcnt++;
    XtSetArg(args[argcnt], XmNindicatorType, XmN_OF_MANY); argcnt++;
    hidden_toggle = XtCreateWidget("hidden_toggle", xmToggleButtonWidgetClass,
		pulldown_menu2, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(hidden_toggle, XmNvalueChangedCallback, XshHiddenFiles, 
	(caddr_t)&XshCbs);
    XtManageChild(hidden_toggle);
 
    argcnt = 0;
    separator1 = XtCreateWidget("separator1", xmSeparatorWidgetClass,
		pulldown_menu2, args, argcnt);

    XtManageChild(separator1);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;

    menu_shell3 = XtCreatePopupShell("menu_shell3", xmMenuShellWidgetClass,
		menu_shell2, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    sort_pulldown_menu = XtCreateWidget("sort_pulldown_menu",
		xmRowColumnWidgetClass, menu_shell3, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Name", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, ""); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'N'); argcnt++;
    byname_button = XtCreateWidget("byname_button", xmPushButtonWidgetClass,
		sort_pulldown_menu, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(byname_button, XmNactivateCallback, XshSortByName, 
		(caddr_t)&XshCbs);
    XtManageChild(byname_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Date", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'D'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, ""); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    bydate_button = XtCreateWidget("bydate_button", xmPushButtonWidgetClass,
		sort_pulldown_menu, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(bydate_button, XmNactivateCallback, XshSortByDate, (caddr_t)&XshCbs);
    XtManageChild(bydate_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Size", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'S'); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    bysize_button = XtCreateWidget("bysize_button", xmPushButtonWidgetClass,
		sort_pulldown_menu, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(bysize_button, XmNactivateCallback, XshSortBySize, 
	(caddr_t)&XshCbs);
    XtManageChild(bysize_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Type", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'T'); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    bytype_button = XtCreateWidget("bytype_button", xmPushButtonWidgetClass,
		sort_pulldown_menu, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(bytype_button, XmNactivateCallback, XshSortByType, 
		(caddr_t)&XshCbs);
    XtManageChild(bytype_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy=XmStringCreateLtoR( "Sort", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'S'); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, sort_pulldown_menu); argcnt++;
    sort_cascade = XtCreateWidget("sort_cascade", xmCascadeButtonWidgetClass,
		pulldown_menu2, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(sort_cascade);
 
    argcnt = 0;
    separatorH = XtCreateWidget("separatorH", xmSeparatorWidgetClass,
		pulldown_menu2, args, argcnt);

    XtManageChild(separatorH);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Arrange Icons ",XmSTRING_DEFAULT_CHARSET)); 	argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'A'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, ""); argcnt++;
    cleanup_button = XtCreateWidget("cleanup_button", xmPushButtonWidgetClass,
		pulldown_menu2, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(cleanup_button, XmNactivateCallback, XshCleanupWindow, 
	(caddr_t)&XshCbs);
    XtManageChild(cleanup_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "View", XmSTRING_DEFAULT_CHARSET));argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'V'); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldown_menu2); argcnt++;
    view_cascade = XtCreateWidget("view_cascade", xmCascadeButtonWidgetClass,
		menu_bar, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(view_cascade);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;

    menu_shell4 = XtCreatePopupShell("menu_shell4", xmMenuShellWidgetClass,
		menu_bar, args, argcnt);

    XtManageChild(menu_shell4);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmnemonic, 'H'); argcnt++;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    pulldown_menu3 = XtCreateWidget("pulldown_menu3", xmRowColumnWidgetClass,
		menu_shell4, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
dummy = XmStringCreateLtoR( "On Freedom Software", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'S'); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    onFSButton = XtCreateWidget("onFSButton", xmPushButtonWidgetClass,
		pulldown_menu3, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(onFSButton, XmNactivateCallback, helpCB, (caddr_t)0);
    XtManageChild(onFSButton);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
dummy = XmStringCreateLtoR( "On Version", XmSTRING_DEFAULT_CHARSET));argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'V'); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    onVersionButton = XtCreateWidget("onVersionButton", xmPushButtonWidgetClass,
		pulldown_menu3, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(onVersionButton, XmNactivateCallback, helpCB, (caddr_t)1);
    XtManageChild(onVersionButton);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
dummy = XmStringCreateLtoR( "On Freedom Desktop", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'D'); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    onFreedomDesktopButton = XtCreateWidget("onFreedomDesktopButton",
		xmPushButtonWidgetClass, pulldown_menu3, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(onFreedomDesktopButton, XmNactivateCallback, helpCB, (caddr_t)2);
    XtManageChild(onFreedomDesktopButton);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Help", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldown_menu3); argcnt++;
    help_cascade = XtCreateWidget("help_cascade", xmCascadeButtonWidgetClass,
		menu_bar, args, argcnt);
    XmStringFree( dummy );

    createMenuForm(help_cascade, (caddr_t)30, (caddr_t)0);
    XtManageChild(help_cascade);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;

    menu_shell5 = XtCreatePopupShell("menu_shell5",
	          xmMenuShellWidgetClass, menu_bar, args, argcnt);

    XtManageChild(menu_shell5);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    pulldown_menu4 = XtCreateWidget("pulldown_menu4", xmRowColumnWidgetClass,
		menu_shell5, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
dummy = XmStringCreateLtoR( "Actions", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldown_menu4); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'A'); argcnt++;
    actions_cascade = XtCreateWidget("actions_cascade",
		xmCascadeButtonWidgetClass, menu_bar, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(actions_cascade, XmNcascadingCallback, 
	XshCreateActionMenu, (caddr_t)&XshCbs);
    createMenuForm(actions_cascade, (caddr_t)16, (caddr_t)0);
    XtManageChild(actions_cascade);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;

    menu_shell6 = XtCreatePopupShell("menu_shell6", xmMenuShellWidgetClass,
		menu_bar, args, argcnt);

    XtManageChild(menu_shell6);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    pulldown_menu5 = XtCreateWidget("pulldown_menu5", xmRowColumnWidgetClass,
		menu_shell6, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Open Trash ..", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>T"); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'T'); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
    dummy1 = XmStringCreateLtoR( "Alt+Shift+T", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    open_trash_button = XtCreateWidget("open_trash_button",
		xmPushButtonWidgetClass, pulldown_menu5, args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(open_trash_button, XmNactivateCallback, XshOpenTrash, 
	(caddr_t)0);
    XtManageChild(open_trash_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Empty Trash", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'E'); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    empty_trash_button = XtCreateWidget("empty_trash_button",
		xmPushButtonWidgetClass, pulldown_menu5, args,
		argcnt);
    XmStringFree( dummy );

    XtAddCallback(empty_trash_button, XmNactivateCallback, XshEmptyTrash, 
	(caddr_t)&XshCbs);
    XtManageChild(empty_trash_button);
 
    argcnt = 0;
    separatorJ = XtCreateWidget("separatorJ", xmSeparatorWidgetClass,
		pulldown_menu5, args, argcnt);

    XtManageChild(separatorJ);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Synchronize", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'S'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Alt Shift<Key>S"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, 
    dummy1 = XmStringCreateLtoR( "Alt+Shift+S", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    synchronize_button = XtCreateWidget("synchronize_button",
		xmPushButtonWidgetClass, pulldown_menu5, args,
		argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );

    XtAddCallback(synchronize_button, XmNactivateCallback, XshSynchronize, 
	(caddr_t)&XshCbs);
    XtManageChild(synchronize_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Utilities", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldown_menu5); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'U'); argcnt++;
    util_cascade = XtCreateWidget("util_cascade", xmCascadeButtonWidgetClass,
		menu_bar, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(util_cascade);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;

    menu_shell7 = XtCreatePopupShell("menu_shell7", xmMenuShellWidgetClass,
		menu_bar, args, argcnt);

    XtManageChild(menu_shell7);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    pulldown_menu6 = XtCreateWidget("pulldown_menu6", xmRowColumnWidgetClass,
		menu_shell7, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy= XmStringCreateLtoR( "Keep Synchronized", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'S'); argcnt++;
    XtSetArg(args[argcnt], XmNvisibleWhenOff, False); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    keep_synchronized_toggle = XtCreateWidget("keep_synchronized_toggle",
		xmToggleButtonWidgetClass, pulldown_menu6, args,
		argcnt);
    XmStringFree( dummy );

    XtAddCallback(keep_synchronized_toggle, XmNvalueChangedCallback, 
	XshKeepSynchronized, (caddr_t)&XshCbs);
    XtManageChild(keep_synchronized_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Terminal Mode", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'T'); argcnt++;
    XtSetArg(args[argcnt], XmNset, False); argcnt++;
    XtSetArg(args[argcnt], XmNvisibleWhenOff, False); argcnt++;

    terminal_mode_toggle = XtCreateWidget("terminal_mode_toggle",
		xmToggleButtonWidgetClass, pulldown_menu6, args,
		argcnt);
    XmStringFree( dummy );

    XtAddCallback(terminal_mode_toggle, XmNvalueChangedCallback, 
	XshTerminalMode, (caddr_t)&XshCbs);
    XtManageChild(terminal_mode_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Options", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'O'); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldown_menu6); argcnt++;
    option_cascade = XtCreateWidget("option_cascade", xmCascadeButtonWidgetClass,
		menu_bar, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(option_cascade);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNmenuHelpWidget, help_cascade); argcnt++;
    XtSetValues(menu_bar, args, argcnt);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 594); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 446); argcnt++;
    form = XtCreateWidget("form", xmFormWidgetClass, main_window, args,
		argcnt);

    XtManageChild(form);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    label = XtCreateWidget("label", xmLabelWidgetClass, form, args,
		argcnt);

    setXshPixmap(label, (caddr_t)0, (caddr_t)0);
    XtManageChild(label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
dummy = XmStringCreateLtoR( "Directory:", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;

    directory_label = XtCreateWidget("directory_label", xmLabelWidgetClass,
		form, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(directory_label);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNrows, 1); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 80); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, label); argcnt++;

    XtSetArg(args[argcnt], XmNtopOffset, -5); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++
;
    XtSetArg(args[argcnt], XmNtopWidget, directory_label); argcnt++;

    directory_text = XtCreateWidget("directory_text", xmTextWidgetClass,
                form, args, argcnt);
    XtAddCallback(directory_text, XmNactivateCallback, XshSetDirectory, (caddr_t
)&XshCbs);
    XshDirTextCreate(directory_text, (caddr_t)0, (caddr_t)0);
    XtManageChild(directory_text);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 1); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 1); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 25); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, directory_label); argcnt++;
    separatorA = XtCreateWidget("separatorA", xmSeparatorWidgetClass,
                form, args, argcnt);

    XtManageChild(separatorA);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginWidth, 3); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomPosition, 90); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 594); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 316); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, separatorA); argcnt++;
    paned_window = XtCreateWidget("paned_window", xmPanedWindowWidgetClass,
		form, args, argcnt);

    XtManageChild(paned_window);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
    XtSetArg(args[argcnt], XmNallowResize, False); argcnt++;
    XtSetArg(args[argcnt], XmNpaneMinimum, 100); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 3); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 588); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 310); argcnt++;
    paned_window1 = XtCreateWidget("paned_window1", xmPanedWindowWidgetClass,
		paned_window, args, argcnt);

    XshPanedWindowCreate(paned_window1, (caddr_t)0, (caddr_t)0);
    XtManageChild(paned_window1);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNscrollingPolicy, XmAUTOMATIC); argcnt++;
    XtSetArg(args[argcnt], XmNscrollBarDisplayPolicy, XmSTATIC); argcnt++;
    XtSetArg(args[argcnt], XmNscrollBarPlacement, XmBOTTOM_LEFT); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 3); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 588); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 304); argcnt++;
    scrolled_window = XtCreateWidget("scrolled_window",
		xmScrolledWindowWidgetClass, paned_window1, args, argcnt);

    ScrollCreate(scrolled_window, (caddr_t)&XshCbs, (caddr_t)0);
    XtManageChild(scrolled_window);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, paned_window); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 1); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 1); argcnt++;
    separatorB = XtCreateWidget("separatorB", xmSeparatorWidgetClass,
                form, args, argcnt);

    XtManageChild(separatorB);


    return( main_window );
}

Widget Create_selection_box(parent)
Widget parent;
{
    Arg    	args[36];
    int    	argcnt;
    XmString	dummy, dummy1, dummy2, dummy3, dummy4, dummy5;
    Widget	selection_box;

 
    dummy = XmStringCreateLtoR( "Create Directory", XmSTRING_DEFAULT_CHARSET); 
    dummy1 = XmStringCreateLtoR( "Directory Name", XmSTRING_DEFAULT_CHARSET); 

    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNmappedWhenManaged, True); argcnt++;
    XtSetArg(args[argcnt], XmNallowOverlap, True); argcnt++;
    XtSetArg(args[argcnt], XmNdialogTitle, dummy ); argcnt++;
    XtSetArg(args[argcnt], XmNselectionLabelString, dummy1); argcnt++;
    XtSetArg(args[argcnt], XmNokLabelString, 
	dummy2=XmStringCreateLtoR( "OK", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNapplyLabelString, 
	dummy3=XmStringCreateLtoR( "Apply", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNcancelLabelString, 
	dummy4=XmStringCreateLtoR( "Cancel", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNhelpLabelString, (dummy5=XmStringCreateLtoR(
		"Help",
		XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNdialogType, XmDIALOG_PROMPT); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 172); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 113); argcnt++;
    selection_box = XtCreateWidget("selection_box", xmSelectionBoxWidgetClass,
		parent, args, argcnt);
    XmStringFree( dummy );
    XmStringFree( dummy1 );
    XmStringFree( dummy2 );
    XmStringFree( dummy3 );
    XmStringFree( dummy4 );
    XmStringFree( dummy5 );

    XtAddCallback(selection_box, XmNokCallback, XshDirCreate, (caddr_t)&XshCbs);

    return( selection_box );
}

Widget Create_directory_selection(parent)
Widget parent;
{
    Arg    	args[36];
    int    	argcnt;
    XmString	dummy, dummy1;
    Widget	directory_selection;
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginHeight, 10); argcnt++;
    XtSetArg(args[argcnt], XmNautoUnmanage, True); argcnt++;
    XtSetArg(args[argcnt], XmNlistVisibleItemCount, 7); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 380); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 212); argcnt++;
    directory_selection = XtCreateWidget("directory_selection",
		xmFileSelectionBoxWidgetClass, parent, args, argcnt);

    XshFileSBoxCreate(directory_selection, (caddr_t)0, (caddr_t)0);

    return( directory_selection );
}

Widget Createform1(parent)
Widget parent;
{
    Arg    	args[36];
    register  int    	argcnt;
    XmString	dummy, dummy1;
    Widget	to_label;
    Widget	ok_button;
    Widget	to_text;
    Widget	separatorI;
    Widget	from_text;
    Widget	current_label;
    Widget	form1;
    Widget	from_label;
    Widget	cancel_button;


 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNnoResize, False); argcnt++;
    XtSetArg(args[argcnt], XmNfractionBase, 7); argcnt++;
    XtSetArg(args[argcnt], XmNrubberPositioning, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 412); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 190); argcnt++;
    form1 = XtCreateWidget("form1", xmFormWidgetClass, parent,
		args, argcnt);

    createCopyMoveForm(form1, (caddr_t)0, (caddr_t)0);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString,
    dummy = XmStringCreateLtoR( "Current directory is",
                XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    current_label = XtCreateWidget("current_label", xmLabelWidgetClass,
                form1, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(current_label);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, current_label); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "From:", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    from_label = XtCreateWidget("from_label", xmLabelWidgetClass, form1,
		args, argcnt);
    XmStringFree( dummy );

    XtManageChild(from_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNrows, 1); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, from_label); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, from_label); argcnt++;
    from_text = XtCreateWidget("from_text", xmTextWidgetClass, form1,
		args, argcnt);

    XtManageChild(from_text);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 15); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, from_label); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, from_label); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "To:", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    to_label = XtCreateWidget("to_label", xmLabelWidgetClass, form1,
		args, argcnt);
    XmStringFree( dummy );

    XtManageChild(to_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNrows, 1); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;

    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, to_label); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, from_text); argcnt++;
    to_text = XtCreateWidget("to_text", xmTextWidgetClass, form1,
		args, argcnt);

    XtManageChild(to_text);
 
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, to_text); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 2); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 2); argcnt++;
    separatorI = XtCreateWidget("separatorI", xmSeparatorWidgetClass,
		form1, args, argcnt);

    XtManageChild(separatorI);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, separatorI); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString,
    dummy = XmStringCreateLtoR( "OK", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNshowAsDefault, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 1); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 60); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 32); argcnt++;
    ok_button = XtCreateWidget("ok_button", xmPushButtonWidgetClass, form1,
                args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(ok_button, XmNactivateCallback, okCopyMoveCB, (caddr_t)&XshCbs);
    XtManageChild(ok_button);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString,
    dummy = XmStringCreateLtoR( "Cancel", XmSTRING_DEFAULT_CHARSET));
    argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 5); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 60); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 32); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, ok_button); argcnt++;
    cancel_button = XtCreateWidget("cancel_button", xmPushButtonWidgetClass,
                form1, args, argcnt);
    XmStringFree( dummy );
    XtAddCallback(cancel_button, XmNactivateCallback, cancelCopyMoveCB, (caddr_t
)0);
    XtManageChild(cancel_button);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNdefaultButton, ok_button); argcnt++;
    XtSetValues(form1, args, argcnt);

    return (form1);
}

Widget Createform2(parent)
Widget parent;
{
    Arg    	args[36];
    int    	argcnt;
    XmString	dummy, dummy1;
    Widget	form2;
    Widget	size_label;
    Widget	type_label;
    Widget	nlinks_label;
    Widget	times_label;
    Widget	access_label;
    Widget	modification_label;
    Widget	status_label;
    Widget	permissions_label;
    Widget	name_label;
    Widget	name_text;
    Widget	separatorC;
    Widget	row_column;
    Widget	owner_label1;
    Widget	group_label1;
    Widget	others_label;
    Widget	read1_toggle;
    Widget	read2_toggle;
    Widget	next_button;
    Widget	apply_button;
    Widget	dismiss_button;
    Widget	frame1;
    Widget	read3_toggle;
    Widget	write1_toggle;
    Widget	write2_toggle;
    Widget	write3_toggle;
    Widget	previous_button;
    Widget	form3;
    Widget	execute1_toggle;
    Widget	scrolled_window1;
    Widget	list2;
    Widget	apply_all_toggle;
    Widget	apply1_all_toggle;
    Widget	apply2_all_toggle;
    Widget	execute2_toggle;
    Widget	execute3_toggle;
    Widget	setuid_toggle;
    Widget	setgid_toggle;
    Widget	sticky_toggle;
    Widget	frame;
    Widget	icon_label;
    Widget	linked_to_label;
    Widget	scrolled_window2;
    Widget	list1;
    Widget	owner_label;
    Widget	group_label;

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNautoUnmanage, False); argcnt++;
    XtSetArg(args[argcnt], XmNnoResize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 547); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 695); argcnt++;
    form2 = XtCreateWidget("form2", xmFormWidgetClass, parent, args,
		argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Name",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    name_label = XtCreateWidget("name_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(name_label);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 15); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 30); argcnt++;
    XtSetArg(args[argcnt], XmNmarginHeight, 20); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 110); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 90); argcnt++;
    frame = XtCreateWidget("frame",
		xmFrameWidgetClass, form2, args, argcnt);

    XtManageChild(frame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNrows, 1); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 7); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 13); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, frame); argcnt++;
    name_text = XtCreateWidget("name_text",
		xmTextWidgetClass, form2, args, argcnt);

    createPropertiesForm(name_text, (caddr_t)0, (caddr_t)0);
    XtManageChild(name_text);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
dummy = XmStringCreateLtoR( "Size: ", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 15); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, name_label); argcnt++;
    size_label = XtCreateWidget("size_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(size_label, (caddr_t)1, (caddr_t)0);
    XtManageChild(size_label);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Apply to all selected",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    apply2_all_toggle = XtCreateWidget("apply2_all_toggle",
		xmToggleButtonWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(apply2_all_toggle, (caddr_t)23, (caddr_t)0);
    XtManageChild(apply2_all_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Apply to all selected",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    apply1_all_toggle = XtCreateWidget("apply1_all_toggle",
		xmToggleButtonWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(apply1_all_toggle, (caddr_t)28, (caddr_t)0);
    XtManageChild(apply1_all_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Apply to all selected",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    apply_all_toggle = XtCreateWidget("apply_all_toggle",
		xmToggleButtonWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(apply_all_toggle, (caddr_t)22, (caddr_t)0);
    XtManageChild(apply_all_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNscrollingPolicy, XmAPPLICATION_DEFINED); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 160); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 56); argcnt++;
    scrolled_window1 = XtCreateWidget("scrolled_window1",
		xmScrolledWindowWidgetClass, form2, args, argcnt);

    XtManageChild(scrolled_window1);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Group",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 86); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    group_label = XtCreateWidget("group_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(group_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Owner", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 15); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    owner_label = XtCreateWidget("owner_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(owner_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNscrollingPolicy, XmAPPLICATION_DEFINED); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 160); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 56); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, owner_label); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, owner_label); argcnt++;
    scrolled_window2 = XtCreateWidget("scrolled_window2",
		xmScrolledWindowWidgetClass, form2, args, argcnt);

    XtManageChild(scrolled_window2);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Linked To: ",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    linked_to_label = XtCreateWidget("linked_to_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(linked_to_label, (caddr_t)3, (caddr_t)0);
    XtManageChild(linked_to_label);
 
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 12); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 527); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 144); argcnt++;
    frame1 = XtCreateWidget("frame1",
		xmFrameWidgetClass, form2, args, argcnt);

    XtManageChild(frame1);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR("Dismiss", XmSTRING_DEFAULT_CHARSET)); 
        argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 77); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 80); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 32); argcnt++;
    dismiss_button = XtCreateWidget("dismiss_button",
		xmPushButtonWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(dismiss_button, XmNactivateCallback, propCancelCB, (caddr_t)&XshCbs);
    createPropertiesForm(dismiss_button, (caddr_t)27, (caddr_t)0);
    XtManageChild(dismiss_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Apply", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNshowAsDefault, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 3); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 80); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 32); argcnt++;
    apply_button = XtCreateWidget("apply_button",
		xmPushButtonWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(apply_button, XmNactivateCallback, propApplyCB, (caddr_t)&XshCbs);
    createPropertiesForm(apply_button, (caddr_t)24, (caddr_t)0);
    XtManageChild(apply_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Next", XmSTRING_DEFAULT_CHARSET));argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 28); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 80); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 32); argcnt++;
    next_button = XtCreateWidget("next_button",
		xmPushButtonWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(next_button, XmNactivateCallback, propNextCB, (caddr_t)&XshCbs);
    createPropertiesForm(next_button, (caddr_t)25, (caddr_t)0);
    XtManageChild(next_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Previous", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 53); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 80); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 32); argcnt++;
    previous_button = XtCreateWidget("previous_button",
		xmPushButtonWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    XtAddCallback(previous_button, XmNactivateCallback, propPrevCB, (caddr_t)&XshCbs);
    createPropertiesForm(previous_button, (caddr_t)26, (caddr_t)0);
    XtManageChild(previous_button);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 3); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 2); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, frame1); argcnt++;
    separatorC = XtCreateWidget("separatorC",
		xmSeparatorWidgetClass, form2, args, argcnt);

    XtManageChild(separatorC);
 
 
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Permissions", XmSTRING_DEFAULT_CHARSET)); 
	argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    permissions_label = XtCreateWidget("permissions_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(permissions_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Last status change: ", 
	XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 20); argcnt++;
    status_label = XtCreateWidget("status_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(status_label, (caddr_t)9, (caddr_t)0);
    XtManageChild(status_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Last modification: ",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 20); argcnt++;
    modification_label = XtCreateWidget("modification_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(modification_label, (caddr_t)8, (caddr_t)0);
    XtManageChild(modification_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
	dummy = XmStringCreateLtoR( "Last access: ",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    access_label = XtCreateWidget("access_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(access_label, (caddr_t)7, (caddr_t)0);
    XtManageChild(access_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Access times", XmSTRING_DEFAULT_CHARSET));
    argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 15); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, scrolled_window1); argcnt++;
    times_label = XtCreateWidget("times_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(times_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
dummy = XmStringCreateLtoR( "Number of links: ", XmSTRING_DEFAULT_CHARSET)); 
    argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    nlinks_label = XtCreateWidget("nlinks_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(nlinks_label, (caddr_t)2, (caddr_t)0);
    XtManageChild(nlinks_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
dummy = XmStringCreateLtoR( "Type", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 8); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, frame); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, frame); argcnt++;
    type_label = XtCreateWidget("type_label",
		xmLabelWidgetClass, form2, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(type_label, (caddr_t)4, (caddr_t)0);
    XtManageChild(type_label);
 

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, size_label); argcnt++;
    XtSetValues(nlinks_label, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, times_label); argcnt++;
    XtSetValues(access_label, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, access_label); argcnt++;
    XtSetValues(modification_label, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, modification_label); argcnt++;
    XtSetValues(status_label, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, status_label); argcnt++;
    XtSetValues(permissions_label, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftOffset, 8); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, name_label); argcnt++;
    XtSetValues(name_text, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, separatorC); argcnt++;
    XtSetValues(previous_button, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, separatorC); argcnt++;
    XtSetValues(next_button, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, separatorC); argcnt++;
    XtSetValues(apply_button, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, separatorC); argcnt++;
    XtSetValues(dismiss_button, args, argcnt);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 521); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 140); argcnt++;
    form3 = XtCreateWidget("form3",
		xmFormWidgetClass, frame1, args, argcnt);

    createPropertiesForm(form3, (caddr_t)30, (caddr_t)0);
    XtManageChild(form3);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Sticky bit",
		XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 45); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    sticky_toggle = XtCreateWidget("sticky_toggle",
		xmToggleButtonWidgetClass, form3, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(sticky_toggle, (caddr_t)21, (caddr_t)0);
    XtManageChild(sticky_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNadjustLast, True); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 30); argcnt++;
    XtSetArg(args[argcnt], XmNmarginHeight, 20); argcnt++;
    XtSetArg(args[argcnt], XmNadjustMargin, True); argcnt++;
    XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
    XtSetArg(args[argcnt], XmNnumColumns, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    row_column = XtCreateWidget("row_column", xmRowColumnWidgetClass,
		form3, args, argcnt);

    XtManageChild(row_column);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Owner", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    owner_label1 = XtCreateWidget("owner_label1", xmLabelWidgetClass,
		row_column, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(owner_label1);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Group", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    group_label1 = XtCreateWidget("group_label1", xmLabelWidgetClass,
		row_column, args, argcnt); 
    XmStringFree( dummy );

    XtManageChild(group_label1);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Others", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    others_label = XtCreateWidget("others_label", xmLabelWidgetClass,
		row_column, args, argcnt);
    XmStringFree( dummy );

    XtManageChild(others_label);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Read", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    read1_toggle = XtCreateWidget("read1_toggle", xmToggleButtonWidgetClass,
		row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(read1_toggle, (caddr_t)10, (caddr_t)0);
    XtManageChild(read1_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (dummy = XmStringCreateLtoR(
		"Read",
		XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    read2_toggle = XtCreateWidget("read2_toggle", xmToggleButtonWidgetClass,
		row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(read2_toggle, (caddr_t)14, (caddr_t)0);
    XtManageChild(read2_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Read", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    read3_toggle = XtCreateWidget("read3_toggle", xmToggleButtonWidgetClass,
		row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(read3_toggle, (caddr_t)18, (caddr_t)0);
    XtManageChild(read3_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Write", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    write1_toggle = XtCreateWidget("write1_toggle", xmToggleButtonWidgetClass,
		row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(write1_toggle, (caddr_t)11, (caddr_t)0);
    XtManageChild(write1_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Write", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    write2_toggle = XtCreateWidget("write2_toggle", xmToggleButtonWidgetClass,
		row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(write2_toggle, (caddr_t)15, (caddr_t)0);
    XtManageChild(write2_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Write", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    write3_toggle = XtCreateWidget("write3_toggle", xmToggleButtonWidgetClass,
		row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(write3_toggle, (caddr_t)19, (caddr_t)0);
    XtManageChild(write3_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Execute", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNfillOnSelect, True); argcnt++;
    execute1_toggle = XtCreateWidget("execute1_toggle",
		xmToggleButtonWidgetClass, row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(execute1_toggle, (caddr_t)12, (caddr_t)0);
    XtManageChild(execute1_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Execute", XmSTRING_DEFAULT_CHARSET));argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    execute2_toggle = XtCreateWidget("execute2_toggle",
		xmToggleButtonWidgetClass, row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(execute2_toggle, (caddr_t)16, (caddr_t)0);
    XtManageChild(execute2_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "Execute", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    execute3_toggle = XtCreateWidget("execute3_toggle",
		xmToggleButtonWidgetClass, row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(execute3_toggle, (caddr_t)20, (caddr_t)0);
    XtManageChild(execute3_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "SetUid", XmSTRING_DEFAULT_CHARSET));argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    setuid_toggle = XtCreateWidget("setuid_toggle",
		xmToggleButtonWidgetClass, row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(setuid_toggle, (caddr_t)13, (caddr_t)0);
    XtManageChild(setuid_toggle);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
    dummy = XmStringCreateLtoR( "SetGid", XmSTRING_DEFAULT_CHARSET)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    setgid_toggle = XtCreateWidget("setgid_toggle",
		xmToggleButtonWidgetClass, row_column, args, argcnt);
    XmStringFree( dummy );

    createPropertiesForm(setgid_toggle, (caddr_t)17, (caddr_t)0);
    XtManageChild(setgid_toggle);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 12); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, permissions_label); argcnt++;
    XtSetValues(frame1, args, argcnt);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    icon_label = XtCreateWidget("icon_label",
		xmLabelWidgetClass, frame, args, argcnt);

    setXshPixmap(icon_label, (caddr_t)0, (caddr_t)0);

    createPropertiesForm(icon_label, (caddr_t)29, (caddr_t)0);
    XtManageChild(icon_label);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, nlinks_label); argcnt++;
    XtSetValues(linked_to_label, args, argcnt);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNitemCount, 0); argcnt++;
    XtSetArg(args[argcnt], XmNselectedItemCount, 0); argcnt++;
    XtSetArg(args[argcnt], XmNvisibleItemCount, 4); argcnt++;
    XtSetArg(args[argcnt], XmNlistSizePolicy, XmCONSTANT); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 160); argcnt++;
    list1 = XtCreateWidget("list1",
		xmListWidgetClass, scrolled_window2, args, argcnt);

    createPropertiesForm(list1, (caddr_t)5, (caddr_t)0);
    XtManageChild(list1);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 15); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, linked_to_label); argcnt++;
    XtSetValues(owner_label, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 86); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, owner_label); argcnt++;
    XtSetValues(group_label, args, argcnt);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNitemCount, 0); argcnt++;
    XtSetArg(args[argcnt], XmNvisibleItemCount, 4); argcnt++;
    XtSetArg(args[argcnt], XmNlistSizePolicy, XmCONSTANT); argcnt++;
    XtSetArg(args[argcnt], XmNscrollBarDisplayPolicy, XmDYNAMIC); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 160); argcnt++;
    list2 = XtCreateWidget("list2",
		xmListWidgetClass, scrolled_window1, args, argcnt);

    createPropertiesForm(list2, (caddr_t)6, (caddr_t)0);
    XtManageChild(list2);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, group_label); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, group_label); argcnt++;
    XtSetValues(scrolled_window1, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, permissions_label); argcnt++;
    XtSetValues(apply_all_toggle, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, owner_label); argcnt++;
    XtSetValues(apply1_all_toggle, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, group_label); argcnt++;
    XtSetValues(apply2_all_toggle, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNdefaultButton, dismiss_button); argcnt++;
    XtSetValues(form2, args, argcnt);

    return (form2);
}

Widget Createform4(parent)
Widget parent;
{
    Arg    	args[36];
    register    int    	argcnt;
    XmString	dummy, dummy1;
    Widget	form4;
    Widget	scrolled_window3;
    Widget	dismiss_button1;

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 352); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 372); argcnt++;
    form4 = XtCreateWidget("form4", xmFormWidgetClass, parent, args, argcnt);

 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 32); argcnt++;
    dismiss_button1 = XtCreateWidget("dismiss_button1",
		xmPushButtonWidgetClass, form4, args, argcnt);

    XtManageChild(dismiss_button1);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNscrollingPolicy, XmAUTOMATIC); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNbottomPosition, 80); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 352); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 288); argcnt++;
    scrolled_window3 = XtCreateWidget("scrolled_window3",
		xmScrolledWindowWidgetClass, form4, args, argcnt);

    XtManageChild(scrolled_window3);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNdefaultButton, dismiss_button1); argcnt++;
    XtSetValues(form4, args, argcnt);

    return (form4);
}

